# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: nillion/auth/v1/public_key.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass

import betterproto


class PublicKeyType(betterproto.Enum):
    """A public key type."""

    ED25519 = 0
    """An ED25519 public key."""

    SECP256K1 = 1
    """A SECP256K1 public key."""


@dataclass(eq=False, repr=False)
class PublicKey(betterproto.Message):
    """
    A public key.

     Signatures associated to this public key must be a 64 bytes long sequence which is the result of the
     concatenation of the `r` and `s` scalars in the signature, each encoded in big endian.
    """

    key_type: "PublicKeyType" = betterproto.enum_field(1)
    """The type of this public key."""

    contents: bytes = betterproto.bytes_field(2)
    """
    The contents of this key.
    
     This is dependent on the `key_type` in this key:
    
     * For ED25519 it should be the curve point in its 32 byte compressed form.
     * For SECP256K1 it should be the curve point in its 33 byte compressed form.
    """
