# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: nillion/compute/v1/invoke.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from typing import List

import betterproto


@dataclass(eq=False, repr=False)
class InvokeComputeRequest(betterproto.Message):
    """A request to invoke a computation."""

    signed_receipt: "___payments_v1_receipt__.SignedReceipt" = (
        betterproto.message_field(1)
    )
    """
    The receipt that proves this operation was paid for.
    
     The receipt must be for a `InvokeCompute` operation.
    """

    value_ids: List[bytes] = betterproto.bytes_field(2)
    """
    The value ids for previously stored values being used as parameters to this compute operation.
    """

    bincode_values: bytes = betterproto.bytes_field(3)
    """
    The values being used as compute-time parameters, encoded in bincode format.
    """

    input_bindings: List["InputPartyBinding"] = betterproto.message_field(4)
    """
    The bindings that define which input party in the program is which user in the network.
    """

    output_bindings: List["OutputPartyBinding"] = betterproto.message_field(5)
    """
    The bindings that define which output party in the program is which users in the network.
    """


@dataclass(eq=False, repr=False)
class InvokeComputeResponse(betterproto.Message):
    """A response to a request to invoke a computation."""

    compute_id: bytes = betterproto.bytes_field(1)
    """An identifier for the execution of the computation."""


@dataclass(eq=False, repr=False)
class InputPartyBinding(betterproto.Message):
    """The bindings for input parties in a program."""

    party_name: str = betterproto.string_field(1)
    """The name of the party as defined in the program."""

    user: "___auth_v1_user__.UserId" = betterproto.message_field(2)
    """The user identity this party is being bound to."""


@dataclass(eq=False, repr=False)
class OutputPartyBinding(betterproto.Message):
    """The bindings for output parties in a program."""

    party_name: str = betterproto.string_field(1)
    """The name of the party as defined in the program."""

    users: List["___auth_v1_user__.UserId"] = betterproto.message_field(2)
    """The user identities this party is being bound to."""


from ....auth.v1 import user as ___auth_v1_user__
from ....payments.v1 import receipt as ___payments_v1_receipt__
