# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: nillion/payments/v1/service.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from typing import (
    TYPE_CHECKING,
    Dict,
    Optional,
)

import betterproto
import grpclib
from betterproto.grpc.grpclib_server import ServiceBase


if TYPE_CHECKING:
    import grpclib.server
    from betterproto.grpc.grpclib_client import MetadataLike
    from grpclib.metadata import Deadline


class PaymentsStub(betterproto.ServiceStub):
    """Payments API."""

    async def price_quote(
        self,
        quote_price_quote_request: "quote.PriceQuoteRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "quote.SignedQuote":
        """Generate a price quote for an operation."""

        return await self._unary_unary(
            "/nillion.payments.v1.Payments/PriceQuote",
            quote_price_quote_request,
            quote.SignedQuote,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def payment_receipt(
        self,
        receipt_payment_receipt_request: "receipt.PaymentReceiptRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "receipt.SignedReceipt":
        """Get a payment receipt for a paid operation."""

        return await self._unary_unary(
            "/nillion.payments.v1.Payments/PaymentReceipt",
            receipt_payment_receipt_request,
            receipt.SignedReceipt,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def payments_config(
        self,
        betterproto_lib_google_protobuf_empty: "betterproto_lib_google_protobuf.Empty",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "config.PaymentsConfigResponse":
        """Get the payments configuration for this network."""

        return await self._unary_unary(
            "/nillion.payments.v1.Payments/PaymentsConfig",
            betterproto_lib_google_protobuf_empty,
            config.PaymentsConfigResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def account_balance(
        self,
        betterproto_lib_google_protobuf_empty: "betterproto_lib_google_protobuf.Empty",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "balance.AccountBalanceResponse":
        """Get the user account's balance."""

        return await self._unary_unary(
            "/nillion.payments.v1.Payments/AccountBalance",
            betterproto_lib_google_protobuf_empty,
            balance.AccountBalanceResponse,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )

    async def add_funds(
        self,
        balance_add_funds_request: "balance.AddFundsRequest",
        *,
        timeout: Optional[float] = None,
        deadline: Optional["Deadline"] = None,
        metadata: Optional["MetadataLike"] = None
    ) -> "betterproto_lib_google_protobuf.Empty":
        """Add funds to a user account's balance."""

        return await self._unary_unary(
            "/nillion.payments.v1.Payments/AddFunds",
            balance_add_funds_request,
            betterproto_lib_google_protobuf.Empty,
            timeout=timeout,
            deadline=deadline,
            metadata=metadata,
        )


import betterproto.lib.google.protobuf as betterproto_lib_google_protobuf

from . import (
    balance,
    config,
    quote,
    receipt,
)


class PaymentsBase(ServiceBase):
    """Payments API."""

    async def price_quote(
        self, quote_price_quote_request: "quote.PriceQuoteRequest"
    ) -> "quote.SignedQuote":
        """Generate a price quote for an operation."""

        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def payment_receipt(
        self, receipt_payment_receipt_request: "receipt.PaymentReceiptRequest"
    ) -> "receipt.SignedReceipt":
        """Get a payment receipt for a paid operation."""

        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def payments_config(
        self,
        betterproto_lib_google_protobuf_empty: "betterproto_lib_google_protobuf.Empty",
    ) -> "config.PaymentsConfigResponse":
        """Get the payments configuration for this network."""

        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def account_balance(
        self,
        betterproto_lib_google_protobuf_empty: "betterproto_lib_google_protobuf.Empty",
    ) -> "balance.AccountBalanceResponse":
        """Get the user account's balance."""

        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def add_funds(
        self, balance_add_funds_request: "balance.AddFundsRequest"
    ) -> "betterproto_lib_google_protobuf.Empty":
        """Add funds to a user account's balance."""

        raise grpclib.GRPCError(grpclib.const.Status.UNIMPLEMENTED)

    async def __rpc_price_quote(
        self,
        stream: "grpclib.server.Stream[quote.PriceQuoteRequest, quote.SignedQuote]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.price_quote(request)
        await stream.send_message(response)

    async def __rpc_payment_receipt(
        self,
        stream: "grpclib.server.Stream[receipt.PaymentReceiptRequest, receipt.SignedReceipt]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.payment_receipt(request)
        await stream.send_message(response)

    async def __rpc_payments_config(
        self,
        stream: "grpclib.server.Stream[betterproto_lib_google_protobuf.Empty, config.PaymentsConfigResponse]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.payments_config(request)
        await stream.send_message(response)

    async def __rpc_account_balance(
        self,
        stream: "grpclib.server.Stream[betterproto_lib_google_protobuf.Empty, balance.AccountBalanceResponse]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.account_balance(request)
        await stream.send_message(response)

    async def __rpc_add_funds(
        self,
        stream: "grpclib.server.Stream[balance.AddFundsRequest, betterproto_lib_google_protobuf.Empty]",
    ) -> None:
        request = await stream.recv_message()
        response = await self.add_funds(request)
        await stream.send_message(response)

    def __mapping__(self) -> Dict[str, grpclib.const.Handler]:
        return {
            "/nillion.payments.v1.Payments/PriceQuote": grpclib.const.Handler(
                self.__rpc_price_quote,
                grpclib.const.Cardinality.UNARY_UNARY,
                quote.PriceQuoteRequest,
                quote.SignedQuote,
            ),
            "/nillion.payments.v1.Payments/PaymentReceipt": grpclib.const.Handler(
                self.__rpc_payment_receipt,
                grpclib.const.Cardinality.UNARY_UNARY,
                receipt.PaymentReceiptRequest,
                receipt.SignedReceipt,
            ),
            "/nillion.payments.v1.Payments/PaymentsConfig": grpclib.const.Handler(
                self.__rpc_payments_config,
                grpclib.const.Cardinality.UNARY_UNARY,
                betterproto_lib_google_protobuf.Empty,
                config.PaymentsConfigResponse,
            ),
            "/nillion.payments.v1.Payments/AccountBalance": grpclib.const.Handler(
                self.__rpc_account_balance,
                grpclib.const.Cardinality.UNARY_UNARY,
                betterproto_lib_google_protobuf.Empty,
                balance.AccountBalanceResponse,
            ),
            "/nillion.payments.v1.Payments/AddFunds": grpclib.const.Handler(
                self.__rpc_add_funds,
                grpclib.const.Cardinality.UNARY_UNARY,
                balance.AddFundsRequest,
                betterproto_lib_google_protobuf.Empty,
            ),
        }
